//------------------------------------------------------------------------------
// Copyright (C) 2010 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
package zalewa.delayedproxy.network;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketTimeoutException;

public class ClientReceiver extends DatagramBase implements Runnable
{
	/**
	 * If this is not null it means that thread closed with an error.
	 */
	public Exception fatalError = null;
	
	private boolean bKeepRunning = true;
	private int port = 0;

	public ClientReceiver(int port)
	{
		this.port = port;
	}
	
	public void quit()
	{
		bKeepRunning = false;
	}
	
	@Override
	public void run()
	{
		try
		{
			threadMain();
		}
		catch (Exception exc)
		{
			execThreadFatalErrorListeners(exc);
		}
		finally
		{
			cleanUpSocket();
		}
	}
	
	private void threadMain() throws Exception
	{
		socket = new DatagramSocket(port);
		socket.setSoTimeout(1);
		
		while(bKeepRunning)
		{
			sendAllPackets();
			
			DatagramPacket packet = new DatagramPacket(new byte[PACKET_SIZE], PACKET_SIZE);			

			try
			{
				socket.receive(packet);
				execPacketReceivedListeners(packet);
			}
			catch (SocketTimeoutException exc)
			{
				// Not an error, continue.
			}
		}
	}
}
